<template lang="pug">
  button.button(
    :class='[size, skin]'
    @click='$emit("click")'
  )
    slot
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'

@Component
export default class BaseButton extends Vue {
  @Prop() readonly size: string
  @Prop() readonly skin: string
}
</script>

<style lang="scss" scoped>
@import '../assets/styles/config/variables.scss';

.button {
  height: $button-height;
  background-color: transparent;

  font-size: 16px;
  line-height: 24px;
  border-radius: 60px;

  cursor: pointer;

  &.big {
    width: $big-button-width;

    &:active {
      background: $main-orange-color;
    }
  }

  &.small {
    width: $small-button-width;
  }

  &.install {
    background: linear-gradient(180deg, $main-orange-color 0%, $side-orange-color 100%);
    border: none;

    &:hover {
      background: $side-orange-color;
    }

    &:active {
      background: $main-orange-color;
    }

    &:disabled {
      color: $disable-button-color;
      background: $disable-button-background-color;
    }
  }

  &.sell {
    background: transparent;
    border: 10px solid transparent;
    border-image: url(../assets/img/sell_icon.png) 10 round;

    color: $sell-color;

    &:hover:enabled {
      border: none;
      background: $sell-color;
      color: $gradient-color-bottom;

      filter: drop-shadow(0px 10px 40px $sell-shadow-color);
    }

    &:active:enabled {
      background: transparent;
      border: 2px solid $sell-active-color;
      color: $sell-color;
    }

    &:disabled {
      border: 2px solid $disable-button-background-color;
      color: $disable-button-background-color;
    }
  }

  &.orange-not-filled {
    border: 2px solid $main-orange-color;

    background-color: transparent;

    &:hover:enabled {
      background: $side-orange-color;
      border: none;
    }

    &:active:enabled {
      background: $main-orange-color;
    }

    &:disabled {
      border: 2px solid $disable-button-background-color;
      color: $disable-button-background-color;
    }
  }
}
</style>
